#include <stdio.h>
#define D 20

struct esame {
       char materia[20];
       long matricola;
       char data[11];
       int voto;
       };
       
void inserisci (struct esame V[], int *pn);
void visualizza (struct esame V[], int n);
void elimina (struct esame V[], int *pn);
void ricerca (struct esame V[], int n);
void leggifile (struct esame V[], int *pn);
void salva (struct esame V[], int n);

main() {
       struct esame A[D];
       int ne,scelta;
       
       
       ne=0;
       do {
           printf("\nScegli tra");
           printf("\n1) Inserisci");
           printf("\n2) Visualizza");
           printf("\n3) Elimina");
           printf("\n4) Ricerca");
           printf("\n5) Salva");
           printf("\n6) Inserisci da file");
           printf("\n0) Fine\n");
           scanf("%d",&scelta);
           
           switch(scelta) {
             case 1: inserisci(A,&ne);
                     break;
             case 2: visualizza(A,ne);
                     break;
             case 3: elimina(A,&ne);
                     break;
             case 4: ricerca(A,ne);
                     break;
             case 5: salva(A,ne);
                     break;
             case 6: leggifile(A,&ne);
                     break;
             default:; 
             }
        } while (scelta != 0);
}
                     
void inserisci (struct esame V[], int *pn)
{ 
  struct esame x;
  
  
  if (*pn<D) /* numero elementi presenti < D */
   {
             
     printf("Materia: ");
     scanf("%s",x.materia);
     printf("Matricola: ");
     scanf("%ld",&x.matricola);
     printf("Data esame : ");
     scanf("%s",x.data);
     printf("Voto: ");
     scanf("%d",&x.voto);
     
     /* inserimento nella prima posizione libera  *pn  */
     V[*pn]=x;
     (*pn)++;
   }
   else printf("vettore pieno\n");
}
 
     
     
  
void visualizza (struct esame V[], int n)
{
  int i;
  
  for(i=0;i<n;i++)
    {
      printf("Materia: %s\n",V[i].materia);
      printf("Matricola: %ld\n",V[i].matricola);
      printf("Data esame: %s\n",V[i].data);
      printf("Voto: %d\n",V[i].voto);
      
    }

}
void elimina (struct esame V[], int *pn)
{
     int i,j;
     long matricola;
     
     printf("Matricola dell'elemento da eliminare ");
     scanf("%ld",&matricola);
     
     /* ricerca */
     for(j=0;j<*pn;j++)
      if(matricola==V[j].matricola) /* trovato */
           break;
           
     if( j<*pn)  /* se trovato */
      {  /*  elimina */
         for(i=j;i<*pn-1;i++)
            V[i]=V[i+1];
            
         (*pn)--;
      }
      else printf("Non trovato\n\n");
}


     
     
void ricerca (struct esame V[], int n)
{
     int i;
     long matricola;
     
     printf("Matricola dell'elemento da cercare ");
     scanf("%ld",&matricola);
     
     /* ricerca */
     for(i=0;i<n;i++)
      if(matricola==V[i].matricola) /* trovato */
           break;
           
     if( i<n)  /* se trovato */
      {  /*  visualizza */
         printf("Materia: %s\n",V[i].materia);
         printf("Data esame: %s\n",V[i].data);
         printf("Voto: %d\n",V[i].voto);
      }
      else printf("Non trovato\n\n");
}  
     
void leggifile (struct esame V[], int *pn)
{
     int i,ris;
     FILE *pf;
     char nomefile[30];
     struct esame x;
     
     i=0;
     printf("Nome file\n");
     scanf("%s",nomefile);
     
     pf=fopen(nomefile,"r");
     if(pf!=NULL)
     {
       do {
           ris=fread(&x,sizeof(struct esame),1,pf);
           if(ris!=0)
            {
              V[i]=x;
              i++;
            }
       } while (ris !=0 && i< D);
       fclose(pf);
     }
     else printf("errore in scrittura");
     
     *pn=i;
}

           
void salva (struct esame V[], int n)
{
    int i,ris;
     FILE *pf;
     char nomefile[30];
     struct esame x;
     
    
     printf("Nome file\n");
     scanf("%s",nomefile);
    
     pf=fopen(nomefile,"w");
     if(pf!=NULL)
     { 
       for(i=0;i<n;i++)
         fwrite(&V[i],sizeof(struct esame),1,pf);
       fclose(pf);
     }
     else printf("Errore in scrittura\n");
}
     
       
              
           
